
_TIMER1_ISR:
	PUSH       R30
	PUSH       R31
	PUSH       R27
	IN         R27, SREG+0
	PUSH       R27

;METAL_DET_LFM_ATMEGA8.c,88 :: 		void TIMER1_ISR() iv IVT_ADDR_TIMER1_OVF ics ICS_AUTO {
;METAL_DET_LFM_ATMEGA8.c,90 :: 		conta_ovf1++;  //conta quantos estouros do timer 1 ocorreu.
	LDS        R16, _conta_ovf1+0
	SUBI       R16, 255
	STS        _conta_ovf1+0, R16
;METAL_DET_LFM_ATMEGA8.c,91 :: 		}
L_end_TIMER1_ISR:
	POP        R27
	OUT        SREG+0, R27
	POP        R27
	POP        R31
	POP        R30
	RETI
; end of _TIMER1_ISR

_TIMER0_ISR:
	PUSH       R30
	PUSH       R31
	PUSH       R27
	IN         R27, SREG+0
	PUSH       R27

;METAL_DET_LFM_ATMEGA8.c,100 :: 		void TIMER0_ISR() iv IVT_ADDR_TIMER0_OVF ics ICS_AUTO {
;METAL_DET_LFM_ATMEGA8.c,103 :: 		b=TCNT1L;  //parte L tem que ler primeiro
; b start address is: 16 (R16)
	IN         R16, TCNT1L+0
	LDI        R17, 0
;METAL_DET_LFM_ATMEGA8.c,104 :: 		a=TCNT1H;
; a start address is: 18 (R18)
	IN         R18, TCNT1H+0
	LDI        R19, 0
;METAL_DET_LFM_ATMEGA8.c,105 :: 		salva_tmr1h=a;//salva medio para uso nas rotinas
	STS        _salva_tmr1h+0, R18
; a end address is: 18 (R18)
;METAL_DET_LFM_ATMEGA8.c,106 :: 		salva_tmr1l=b;
	STS        _salva_tmr1l+0, R16
; b end address is: 16 (R16)
;METAL_DET_LFM_ATMEGA8.c,107 :: 		TCNT1H=0;//parte h=0  tem que ser escrita primeiro
	LDI        R27, 0
	OUT        TCNT1H+0, R27
;METAL_DET_LFM_ATMEGA8.c,108 :: 		TCNT1L=0;//zera timer1 h e timer 1l para nova medio
	LDI        R27, 0
	OUT        TCNT1L+0, R27
;METAL_DET_LFM_ATMEGA8.c,109 :: 		salva_overf1=conta_ovf1;
	LDS        R16, _conta_ovf1+0
	STS        _salva_overf1+0, R16
;METAL_DET_LFM_ATMEGA8.c,110 :: 		conta_ovf1=0;
	LDI        R27, 0
	STS        _conta_ovf1+0, R27
;METAL_DET_LFM_ATMEGA8.c,111 :: 		TOV1_bit=1;//reseta flag over flow do timer1  com '1'
	IN         R27, TOV1_bit+0
	SBR        R27, BitMask(TOV1_bit+0)
	OUT        TOV1_bit+0, R27
;METAL_DET_LFM_ATMEGA8.c,112 :: 		flag_ok=1;
	LDS        R27, _flag_ok+0
	SBR        R27, BitMask(_flag_ok+0)
	STS        _flag_ok+0, R27
;METAL_DET_LFM_ATMEGA8.c,113 :: 		TCNT0=salva_tmr0;//recarga do timer 0
	LDS        R16, _salva_tmr0+0
	OUT        TCNT0+0, R16
;METAL_DET_LFM_ATMEGA8.c,114 :: 		}
L_end_TIMER0_ISR:
	POP        R27
	OUT        SREG+0, R27
	POP        R27
	POP        R31
	POP        R30
	RETI
; end of _TIMER0_ISR

_delay10ms:

;METAL_DET_LFM_ATMEGA8.c,118 :: 		void delay10ms(){
;METAL_DET_LFM_ATMEGA8.c,120 :: 		asm WDR ; //reseta WDT
	WDR
;METAL_DET_LFM_ATMEGA8.c,121 :: 		delay_ms(10);
	LDI        R17, 208
	LDI        R16, 202
L_delay10ms0:
	DEC        R16
	BRNE       L_delay10ms0
	DEC        R17
	BRNE       L_delay10ms0
	NOP
;METAL_DET_LFM_ATMEGA8.c,122 :: 		asm WDR ;
	WDR
;METAL_DET_LFM_ATMEGA8.c,123 :: 		}
L_end_delay10ms:
	RET
; end of _delay10ms

_delay100ms:

;METAL_DET_LFM_ATMEGA8.c,127 :: 		void delay100ms(){
;METAL_DET_LFM_ATMEGA8.c,130 :: 		for(a=0;a<10;a++)delay10ms();
; a start address is: 17 (R17)
	LDI        R17, 0
; a end address is: 17 (R17)
L_delay100ms2:
; a start address is: 17 (R17)
	CPI        R17, 10
	BRLO       L__delay100ms126
	JMP        L_delay100ms3
L__delay100ms126:
	PUSH       R17
	CALL       _delay10ms+0
	POP        R17
	MOV        R16, R17
	SUBI       R16, 255
	MOV        R17, R16
; a end address is: 17 (R17)
	JMP        L_delay100ms2
L_delay100ms3:
;METAL_DET_LFM_ATMEGA8.c,131 :: 		}
L_end_delay100ms:
	RET
; end of _delay100ms

_initial_config:

;METAL_DET_LFM_ATMEGA8.c,136 :: 		void initial_config(){
;METAL_DET_LFM_ATMEGA8.c,138 :: 		TCCR0=0b00000111; //timer0 conta com pulso externos do pino 8 (PD4)
	LDI        R27, 7
	OUT        TCCR0+0, R27
;METAL_DET_LFM_ATMEGA8.c,139 :: 		ACSR=0X80; //desliga comparador (economia de energia)
	LDI        R27, 128
	OUT        ACSR+0, R27
;METAL_DET_LFM_ATMEGA8.c,140 :: 		DDRB=0B00001111;//todos os pinos como sada
	LDI        R27, 15
	OUT        DDRB+0, R27
;METAL_DET_LFM_ATMEGA8.c,141 :: 		DDRD=0B11101111;//entradas e sadas
	LDI        R27, 239
	OUT        DDRD+0, R27
;METAL_DET_LFM_ATMEGA8.c,142 :: 		PORTB=0;
	LDI        R27, 0
	OUT        PORTB+0, R27
;METAL_DET_LFM_ATMEGA8.c,143 :: 		PORTD=0;
	LDI        R27, 0
	OUT        PORTD+0, R27
;METAL_DET_LFM_ATMEGA8.c,144 :: 		flag_ok=0;//flag indicador de nova leitura do timer 1 durante interrupo do tmr0
	LDS        R27, _flag_ok+0
	CBR        R27, BitMask(_flag_ok+0)
	STS        _flag_ok+0, R27
;METAL_DET_LFM_ATMEGA8.c,145 :: 		flag_g1=0;//flag geral 1
	LDS        R27, _flag_g1+0
	CBR        R27, BitMask(_flag_g1+0)
	STS        _flag_g1+0, R27
;METAL_DET_LFM_ATMEGA8.c,146 :: 		flag_g2=0;//flag geral 2
	LDS        R27, _flag_g2+0
	CBR        R27, BitMask(_flag_g2+0)
	STS        _flag_g2+0, R27
;METAL_DET_LFM_ATMEGA8.c,147 :: 		flag_fnf=0;//flag indicador de metal ferroso ou no ferroso
	LDS        R27, _flag_fnf+0
	CBR        R27, BitMask(_flag_fnf+0)
	STS        _flag_fnf+0, R27
;METAL_DET_LFM_ATMEGA8.c,148 :: 		flag_ovft0=0;//flag auxiliar indicador de ocorrncia de estouro no timer 0
	LDS        R27, _flag_ovft0+0
	CBR        R27, BitMask(_flag_ovft0+0)
	STS        _flag_ovft0+0, R27
;METAL_DET_LFM_ATMEGA8.c,149 :: 		delay100ms();//delay total de 300 ms
	CALL       _delay100ms+0
;METAL_DET_LFM_ATMEGA8.c,150 :: 		delay100ms();
	CALL       _delay100ms+0
;METAL_DET_LFM_ATMEGA8.c,151 :: 		delay100ms();
	CALL       _delay100ms+0
;METAL_DET_LFM_ATMEGA8.c,152 :: 		SREG_I_bit = 0;  // Desliga geral das interrupes
	IN         R27, SREG_I_bit+0
	CBR        R27, BitMask(SREG_I_bit+0)
	OUT        SREG_I_bit+0, R27
;METAL_DET_LFM_ATMEGA8.c,153 :: 		TCNT0=0;//zera timer 0
	LDI        R27, 0
	OUT        TCNT0+0, R27
;METAL_DET_LFM_ATMEGA8.c,154 :: 		asm WDR ;//RESETA WDT
	WDR
;METAL_DET_LFM_ATMEGA8.c,155 :: 		WDTCR=0B00001010; //WDT com 60 ms
	LDI        R27, 10
	OUT        WDTCR+0, R27
;METAL_DET_LFM_ATMEGA8.c,156 :: 		TCCR1A=0;
	LDI        R27, 0
	OUT        TCCR1A+0, R27
;METAL_DET_LFM_ATMEGA8.c,157 :: 		TCCR1B=1; //timer 1 sem prescaller sinal clock interno
	LDI        R27, 1
	OUT        TCCR1B+0, R27
;METAL_DET_LFM_ATMEGA8.c,158 :: 		TIMSK=0B00000001;//Liga interrupo de overflow do timer0
	LDI        R27, 1
	OUT        TIMSK+0, R27
;METAL_DET_LFM_ATMEGA8.c,159 :: 		}
L_end_initial_config:
	RET
; end of _initial_config

_var_delay_us:

;METAL_DET_LFM_ATMEGA8.c,165 :: 		void var_delay_us(char v){
;METAL_DET_LFM_ATMEGA8.c,167 :: 		if(v>=3)v=v-3; else return;
	LDI        R27, 3
	CP         R2, R27
	BRSH       L__var_delay_us129
	JMP        L_var_delay_us5
L__var_delay_us129:
	MOV        R16, R2
	SUBI       R16, 3
	MOV        R2, R16
	JMP        L_var_delay_us6
L_var_delay_us5:
	JMP        L_end_var_delay_us
L_var_delay_us6:
;METAL_DET_LFM_ATMEGA8.c,168 :: 		while(v){
L_var_delay_us7:
	TST        R2
	BRNE       L__var_delay_us130
	JMP        L_var_delay_us8
L__var_delay_us130:
;METAL_DET_LFM_ATMEGA8.c,169 :: 		v--;
	MOV        R16, R2
	SUBI       R16, 1
	MOV        R2, R16
;METAL_DET_LFM_ATMEGA8.c,170 :: 		asm NOP;
	NOP
;METAL_DET_LFM_ATMEGA8.c,171 :: 		asm NOP;
	NOP
;METAL_DET_LFM_ATMEGA8.c,172 :: 		asm NOP;
	NOP
;METAL_DET_LFM_ATMEGA8.c,173 :: 		asm NOP;
	NOP
;METAL_DET_LFM_ATMEGA8.c,174 :: 		asm NOP;
	NOP
;METAL_DET_LFM_ATMEGA8.c,175 :: 		asm NOP;
	NOP
;METAL_DET_LFM_ATMEGA8.c,176 :: 		asm NOP;
	NOP
;METAL_DET_LFM_ATMEGA8.c,177 :: 		asm NOP;
	NOP
;METAL_DET_LFM_ATMEGA8.c,178 :: 		asm NOP;
	NOP
;METAL_DET_LFM_ATMEGA8.c,179 :: 		asm WDR ;
	WDR
;METAL_DET_LFM_ATMEGA8.c,180 :: 		}
	JMP        L_var_delay_us7
L_var_delay_us8:
;METAL_DET_LFM_ATMEGA8.c,181 :: 		}
L_end_var_delay_us:
	RET
; end of _var_delay_us

_gera_beep:

;METAL_DET_LFM_ATMEGA8.c,187 :: 		void gera_beep(char d,char e){
;METAL_DET_LFM_ATMEGA8.c,190 :: 		PORTD=0;
	LDI        R27, 0
	OUT        PORTD+0, R27
;METAL_DET_LFM_ATMEGA8.c,191 :: 		ledf=0;
	IN         R27, PORTB3_bit+0
	CBR        R27, BitMask(PORTB3_bit+0)
	OUT        PORTB3_bit+0, R27
;METAL_DET_LFM_ATMEGA8.c,192 :: 		lednf=0;
	IN         R27, PORTB2_bit+0
	CBR        R27, BitMask(PORTB2_bit+0)
	OUT        PORTB2_bit+0, R27
;METAL_DET_LFM_ATMEGA8.c,193 :: 		for(c=0;c<d;c++){
; c start address is: 17 (R17)
	LDI        R17, 0
; c end address is: 17 (R17)
L_gera_beep9:
; c start address is: 17 (R17)
	CP         R17, R2
	BRLO       L__gera_beep132
	JMP        L_gera_beep10
L__gera_beep132:
;METAL_DET_LFM_ATMEGA8.c,194 :: 		buzzer=1;
	IN         R27, PORTB1_bit+0
	SBR        R27, BitMask(PORTB1_bit+0)
	OUT        PORTB1_bit+0, R27
;METAL_DET_LFM_ATMEGA8.c,195 :: 		var_delay_us(e);
	PUSH       R2
	MOV        R2, R3
	CALL       _var_delay_us+0
;METAL_DET_LFM_ATMEGA8.c,196 :: 		buzzer=0;
	IN         R27, PORTB1_bit+0
	CBR        R27, BitMask(PORTB1_bit+0)
	OUT        PORTB1_bit+0, R27
;METAL_DET_LFM_ATMEGA8.c,197 :: 		var_delay_us(e);
	MOV        R2, R3
	CALL       _var_delay_us+0
	POP        R2
;METAL_DET_LFM_ATMEGA8.c,193 :: 		for(c=0;c<d;c++){
	MOV        R16, R17
	SUBI       R16, 255
	MOV        R17, R16
;METAL_DET_LFM_ATMEGA8.c,198 :: 		}//for(c=0;c<=d;c++){
; c end address is: 17 (R17)
	JMP        L_gera_beep9
L_gera_beep10:
;METAL_DET_LFM_ATMEGA8.c,199 :: 		}//void gera_beep(d,e){
L_end_gera_beep:
	RET
; end of _gera_beep

_beep_erros:
	PUSH       R28
	PUSH       R29
	IN         R28, SPL+0
	IN         R29, SPL+1
	SBIW       R28, 1
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	ADIW       R28, 1

;METAL_DET_LFM_ATMEGA8.c,212 :: 		void beep_erros(char n){
;METAL_DET_LFM_ATMEGA8.c,215 :: 		for(d=0;d<8;d++){  // beep longo
	PUSH       R3
	LDI        R27, 0
	STD        Y+0, R27
L_beep_erros12:
	LDD        R16, Y+0
	CPI        R16, 8
	BRLO       L__beep_erros134
	JMP        L_beep_erros13
L__beep_erros134:
;METAL_DET_LFM_ATMEGA8.c,216 :: 		gera_beep(255,255);
	PUSH       R2
	LDI        R27, 255
	MOV        R3, R27
	LDI        R27, 255
	MOV        R2, R27
	CALL       _gera_beep+0
	POP        R2
;METAL_DET_LFM_ATMEGA8.c,215 :: 		for(d=0;d<8;d++){  // beep longo
	LDD        R16, Y+0
	SUBI       R16, 255
	STD        Y+0, R16
;METAL_DET_LFM_ATMEGA8.c,217 :: 		}
	JMP        L_beep_erros12
L_beep_erros13:
;METAL_DET_LFM_ATMEGA8.c,218 :: 		for(d=0;d<10;d++){//1 segundo de delay
	LDI        R27, 0
	STD        Y+0, R27
L_beep_erros15:
	LDD        R16, Y+0
	CPI        R16, 10
	BRLO       L__beep_erros135
	JMP        L_beep_erros16
L__beep_erros135:
;METAL_DET_LFM_ATMEGA8.c,219 :: 		delay100ms();
	CALL       _delay100ms+0
;METAL_DET_LFM_ATMEGA8.c,218 :: 		for(d=0;d<10;d++){//1 segundo de delay
	LDD        R16, Y+0
	SUBI       R16, 255
	STD        Y+0, R16
;METAL_DET_LFM_ATMEGA8.c,220 :: 		}
	JMP        L_beep_erros15
L_beep_erros16:
;METAL_DET_LFM_ATMEGA8.c,221 :: 		for(d=0;d<n;d++){
	LDI        R27, 0
	STD        Y+0, R27
L_beep_erros18:
	LDD        R16, Y+0
	CP         R16, R2
	BRLO       L__beep_erros136
	JMP        L_beep_erros19
L__beep_erros136:
;METAL_DET_LFM_ATMEGA8.c,222 :: 		gera_beep(230,150);
	PUSH       R2
	LDI        R27, 150
	MOV        R3, R27
	LDI        R27, 230
	MOV        R2, R27
	CALL       _gera_beep+0
	POP        R2
;METAL_DET_LFM_ATMEGA8.c,223 :: 		delay100ms();
	CALL       _delay100ms+0
;METAL_DET_LFM_ATMEGA8.c,224 :: 		delay100ms();
	CALL       _delay100ms+0
;METAL_DET_LFM_ATMEGA8.c,225 :: 		delay100ms();
	CALL       _delay100ms+0
;METAL_DET_LFM_ATMEGA8.c,226 :: 		delay100ms();
	CALL       _delay100ms+0
;METAL_DET_LFM_ATMEGA8.c,221 :: 		for(d=0;d<n;d++){
	LDD        R16, Y+0
	SUBI       R16, 255
	STD        Y+0, R16
;METAL_DET_LFM_ATMEGA8.c,227 :: 		}
	JMP        L_beep_erros18
L_beep_erros19:
;METAL_DET_LFM_ATMEGA8.c,228 :: 		for(d=0;d<30;d++){//delay de 3 segundos
	LDI        R27, 0
	STD        Y+0, R27
L_beep_erros21:
	LDD        R16, Y+0
	CPI        R16, 30
	BRLO       L__beep_erros137
	JMP        L_beep_erros22
L__beep_erros137:
;METAL_DET_LFM_ATMEGA8.c,229 :: 		delay100ms();
	CALL       _delay100ms+0
;METAL_DET_LFM_ATMEGA8.c,228 :: 		for(d=0;d<30;d++){//delay de 3 segundos
	LDD        R16, Y+0
	SUBI       R16, 255
	STD        Y+0, R16
;METAL_DET_LFM_ATMEGA8.c,230 :: 		}
	JMP        L_beep_erros21
L_beep_erros22:
;METAL_DET_LFM_ATMEGA8.c,231 :: 		for(;;);  //Espera reset do WDT
L_beep_erros24:
	JMP        L_beep_erros24
;METAL_DET_LFM_ATMEGA8.c,232 :: 		}//beep_erros()
L_end_beep_erros:
	POP        R3
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	POP        R29
	POP        R28
	RET
; end of _beep_erros

_nonferrous:

;METAL_DET_LFM_ATMEGA8.c,239 :: 		void nonferrous(){
;METAL_DET_LFM_ATMEGA8.c,242 :: 		lednf=1;
	PUSH       R2
	IN         R27, PORTB2_bit+0
	SBR        R27, BitMask(PORTB2_bit+0)
	OUT        PORTB2_bit+0, R27
;METAL_DET_LFM_ATMEGA8.c,243 :: 		ledf=0;
	IN         R27, PORTB3_bit+0
	CBR        R27, BitMask(PORTB3_bit+0)
	OUT        PORTB3_bit+0, R27
;METAL_DET_LFM_ATMEGA8.c,244 :: 		for(a=0;a<=150;a++){
; a start address is: 17 (R17)
	LDI        R17, 0
; a end address is: 17 (R17)
L_nonferrous27:
; a start address is: 17 (R17)
	LDI        R16, 150
	CP         R16, R17
	BRSH       L__nonferrous139
	JMP        L_nonferrous28
L__nonferrous139:
;METAL_DET_LFM_ATMEGA8.c,245 :: 		buzzer=1;
	IN         R27, PORTB1_bit+0
	SBR        R27, BitMask(PORTB1_bit+0)
	OUT        PORTB1_bit+0, R27
;METAL_DET_LFM_ATMEGA8.c,246 :: 		var_delay_us(130);//110
	LDI        R27, 130
	MOV        R2, R27
	CALL       _var_delay_us+0
;METAL_DET_LFM_ATMEGA8.c,247 :: 		buzzer=0;
	IN         R27, PORTB1_bit+0
	CBR        R27, BitMask(PORTB1_bit+0)
	OUT        PORTB1_bit+0, R27
;METAL_DET_LFM_ATMEGA8.c,248 :: 		var_delay_us(130);//110
	LDI        R27, 130
	MOV        R2, R27
	CALL       _var_delay_us+0
;METAL_DET_LFM_ATMEGA8.c,244 :: 		for(a=0;a<=150;a++){
	MOV        R16, R17
	SUBI       R16, 255
	MOV        R17, R16
;METAL_DET_LFM_ATMEGA8.c,249 :: 		}
; a end address is: 17 (R17)
	JMP        L_nonferrous27
L_nonferrous28:
;METAL_DET_LFM_ATMEGA8.c,250 :: 		delay10ms();
	CALL       _delay10ms+0
;METAL_DET_LFM_ATMEGA8.c,251 :: 		lednf=0;
	IN         R27, PORTB2_bit+0
	CBR        R27, BitMask(PORTB2_bit+0)
	OUT        PORTB2_bit+0, R27
;METAL_DET_LFM_ATMEGA8.c,252 :: 		ledf=0;
	IN         R27, PORTB3_bit+0
	CBR        R27, BitMask(PORTB3_bit+0)
	OUT        PORTB3_bit+0, R27
;METAL_DET_LFM_ATMEGA8.c,253 :: 		}
L_end_nonferrous:
	POP        R2
	RET
; end of _nonferrous

_ferrous:

;METAL_DET_LFM_ATMEGA8.c,258 :: 		void ferrous(){
;METAL_DET_LFM_ATMEGA8.c,261 :: 		lednf=0;
	PUSH       R2
	IN         R27, PORTB2_bit+0
	CBR        R27, BitMask(PORTB2_bit+0)
	OUT        PORTB2_bit+0, R27
;METAL_DET_LFM_ATMEGA8.c,262 :: 		ledf=1;
	IN         R27, PORTB3_bit+0
	SBR        R27, BitMask(PORTB3_bit+0)
	OUT        PORTB3_bit+0, R27
;METAL_DET_LFM_ATMEGA8.c,263 :: 		for(a=0;a<=80;a++){
; a start address is: 17 (R17)
	LDI        R17, 0
; a end address is: 17 (R17)
L_ferrous30:
; a start address is: 17 (R17)
	LDI        R16, 80
	CP         R16, R17
	BRSH       L__ferrous141
	JMP        L_ferrous31
L__ferrous141:
;METAL_DET_LFM_ATMEGA8.c,264 :: 		buzzer=1;
	IN         R27, PORTB1_bit+0
	SBR        R27, BitMask(PORTB1_bit+0)
	OUT        PORTB1_bit+0, R27
;METAL_DET_LFM_ATMEGA8.c,265 :: 		var_delay_us(250);
	LDI        R27, 250
	MOV        R2, R27
	CALL       _var_delay_us+0
;METAL_DET_LFM_ATMEGA8.c,266 :: 		buzzer=0;
	IN         R27, PORTB1_bit+0
	CBR        R27, BitMask(PORTB1_bit+0)
	OUT        PORTB1_bit+0, R27
;METAL_DET_LFM_ATMEGA8.c,267 :: 		var_delay_us(250);
	LDI        R27, 250
	MOV        R2, R27
	CALL       _var_delay_us+0
;METAL_DET_LFM_ATMEGA8.c,263 :: 		for(a=0;a<=80;a++){
	MOV        R16, R17
	SUBI       R16, 255
	MOV        R17, R16
;METAL_DET_LFM_ATMEGA8.c,268 :: 		}
; a end address is: 17 (R17)
	JMP        L_ferrous30
L_ferrous31:
;METAL_DET_LFM_ATMEGA8.c,269 :: 		delay10ms();
	CALL       _delay10ms+0
;METAL_DET_LFM_ATMEGA8.c,270 :: 		lednf=0;
	IN         R27, PORTB2_bit+0
	CBR        R27, BitMask(PORTB2_bit+0)
	OUT        PORTB2_bit+0, R27
;METAL_DET_LFM_ATMEGA8.c,271 :: 		ledf=0;
	IN         R27, PORTB3_bit+0
	CBR        R27, BitMask(PORTB3_bit+0)
	OUT        PORTB3_bit+0, R27
;METAL_DET_LFM_ATMEGA8.c,272 :: 		}
L_end_ferrous:
	POP        R2
	RET
; end of _ferrous

_dinamic_adjust_value:

;METAL_DET_LFM_ATMEGA8.c,280 :: 		void dinamic_adjust_value(){
;METAL_DET_LFM_ATMEGA8.c,284 :: 		asm WDR ;
	WDR
;METAL_DET_LFM_ATMEGA8.c,285 :: 		if(old_dif > dif) old_tmr1b=old_tmr1a;//se diferenca anterior  maior que diferena atual
	LDS        R20, _old_dif+0
	LDS        R21, _old_dif+1
	LDS        R22, _old_dif+2
	LDS        R23, _old_dif+3
	LDS        R16, _dif+0
	LDS        R17, _dif+1
	LDS        R18, _dif+2
	LDS        R19, _dif+3
	CP         R16, R20
	CPC        R17, R21
	CPC        R18, R22
	CPC        R19, R23
	BRLT       L__dinamic_adjust_value143
	JMP        L_dinamic_adjust_value33
L__dinamic_adjust_value143:
	LDS        R16, _old_tmr1a+0
	LDS        R17, _old_tmr1a+1
	LDS        R18, _old_tmr1a+2
	LDS        R19, _old_tmr1a+3
	STS        _old_tmr1b+0, R16
	STS        _old_tmr1b+1, R17
	STS        _old_tmr1b+2, R18
	STS        _old_tmr1b+3, R19
L_dinamic_adjust_value33:
;METAL_DET_LFM_ATMEGA8.c,286 :: 		old_dif=dif;//diferena anterior fica com diferena atual
	LDS        R16, _dif+0
	LDS        R17, _dif+1
	LDS        R18, _dif+2
	LDS        R19, _dif+3
	STS        _old_dif+0, R16
	STS        _old_dif+1, R17
	STS        _old_dif+2, R18
	STS        _old_dif+3, R19
;METAL_DET_LFM_ATMEGA8.c,288 :: 		if(old_tmr1c>new_tmr1)old_tmr1c--;
	LDS        R20, _old_tmr1c+0
	LDS        R21, _old_tmr1c+1
	LDS        R22, _old_tmr1c+2
	LDS        R23, _old_tmr1c+3
	LDS        R16, _new_tmr1+0
	LDS        R17, _new_tmr1+1
	LDS        R18, _new_tmr1+2
	LDS        R19, _new_tmr1+3
	CP         R16, R20
	CPC        R17, R21
	CPC        R18, R22
	CPC        R19, R23
	BRLT       L__dinamic_adjust_value144
	JMP        L_dinamic_adjust_value34
L__dinamic_adjust_value144:
	LDS        R16, _old_tmr1c+0
	LDS        R17, _old_tmr1c+1
	LDS        R18, _old_tmr1c+2
	LDS        R19, _old_tmr1c+3
	SUBI       R16, 1
	SBCI       R17, 0
	SBCI       R18, 0
	SBCI       R19, 0
	STS        _old_tmr1c+0, R16
	STS        _old_tmr1c+1, R17
	STS        _old_tmr1c+2, R18
	STS        _old_tmr1c+3, R19
L_dinamic_adjust_value34:
;METAL_DET_LFM_ATMEGA8.c,289 :: 		if(old_tmr1c<new_tmr1)old_tmr1c++;//se valor anterior timer1 c for menor que nova leitura timer1
	LDS        R20, _old_tmr1c+0
	LDS        R21, _old_tmr1c+1
	LDS        R22, _old_tmr1c+2
	LDS        R23, _old_tmr1c+3
	LDS        R16, _new_tmr1+0
	LDS        R17, _new_tmr1+1
	LDS        R18, _new_tmr1+2
	LDS        R19, _new_tmr1+3
	CP         R20, R16
	CPC        R21, R17
	CPC        R22, R18
	CPC        R23, R19
	BRLT       L__dinamic_adjust_value145
	JMP        L_dinamic_adjust_value35
L__dinamic_adjust_value145:
	LDS        R16, _old_tmr1c+0
	LDS        R17, _old_tmr1c+1
	LDS        R18, _old_tmr1c+2
	LDS        R19, _old_tmr1c+3
	SUBI       R16, 255
	SBCI       R17, 255
	SBCI       R18, 255
	SBCI       R19, 255
	STS        _old_tmr1c+0, R16
	STS        _old_tmr1c+1, R17
	STS        _old_tmr1c+2, R18
	STS        _old_tmr1c+3, R19
L_dinamic_adjust_value35:
;METAL_DET_LFM_ATMEGA8.c,291 :: 		cnt1++;
	LDS        R16, _cnt1+0
	SUBI       R16, 255
	STS        _cnt1+0, R16
;METAL_DET_LFM_ATMEGA8.c,292 :: 		if(cnt1>=FATOR1){//rotina realizada a cada FATOR 1 iteraes
	CPI        R16, 15
	BRSH       L__dinamic_adjust_value146
	JMP        L_dinamic_adjust_value36
L__dinamic_adjust_value146:
;METAL_DET_LFM_ATMEGA8.c,293 :: 		cnt1=0;
	LDI        R27, 0
	STS        _cnt1+0, R27
;METAL_DET_LFM_ATMEGA8.c,294 :: 		cnt2++;
	LDS        R16, _cnt2+0
	SUBI       R16, 255
	STS        _cnt2+0, R16
;METAL_DET_LFM_ATMEGA8.c,295 :: 		if(old_tmr1c>old_tmr1b)old_tmr1b++;//c>b=b++
	LDS        R20, _old_tmr1c+0
	LDS        R21, _old_tmr1c+1
	LDS        R22, _old_tmr1c+2
	LDS        R23, _old_tmr1c+3
	LDS        R16, _old_tmr1b+0
	LDS        R17, _old_tmr1b+1
	LDS        R18, _old_tmr1b+2
	LDS        R19, _old_tmr1b+3
	CP         R16, R20
	CPC        R17, R21
	CPC        R18, R22
	CPC        R19, R23
	BRLT       L__dinamic_adjust_value147
	JMP        L_dinamic_adjust_value37
L__dinamic_adjust_value147:
	LDS        R16, _old_tmr1b+0
	LDS        R17, _old_tmr1b+1
	LDS        R18, _old_tmr1b+2
	LDS        R19, _old_tmr1b+3
	SUBI       R16, 255
	SBCI       R17, 255
	SBCI       R18, 255
	SBCI       R19, 255
	STS        _old_tmr1b+0, R16
	STS        _old_tmr1b+1, R17
	STS        _old_tmr1b+2, R18
	STS        _old_tmr1b+3, R19
L_dinamic_adjust_value37:
;METAL_DET_LFM_ATMEGA8.c,296 :: 		if(old_tmr1c<old_tmr1b)old_tmr1b--;//c<b=b--
	LDS        R20, _old_tmr1c+0
	LDS        R21, _old_tmr1c+1
	LDS        R22, _old_tmr1c+2
	LDS        R23, _old_tmr1c+3
	LDS        R16, _old_tmr1b+0
	LDS        R17, _old_tmr1b+1
	LDS        R18, _old_tmr1b+2
	LDS        R19, _old_tmr1b+3
	CP         R20, R16
	CPC        R21, R17
	CPC        R22, R18
	CPC        R23, R19
	BRLT       L__dinamic_adjust_value148
	JMP        L_dinamic_adjust_value38
L__dinamic_adjust_value148:
	LDS        R16, _old_tmr1b+0
	LDS        R17, _old_tmr1b+1
	LDS        R18, _old_tmr1b+2
	LDS        R19, _old_tmr1b+3
	SUBI       R16, 1
	SBCI       R17, 0
	SBCI       R18, 0
	SBCI       R19, 0
	STS        _old_tmr1b+0, R16
	STS        _old_tmr1b+1, R17
	STS        _old_tmr1b+2, R18
	STS        _old_tmr1b+3, R19
L_dinamic_adjust_value38:
;METAL_DET_LFM_ATMEGA8.c,297 :: 		}
L_dinamic_adjust_value36:
;METAL_DET_LFM_ATMEGA8.c,298 :: 		if(cnt2>=FATOR2){//rotina realizada a cada FATOR2 iteraes
	LDS        R16, _cnt2+0
	CPI        R16, 15
	BRSH       L__dinamic_adjust_value149
	JMP        L_dinamic_adjust_value39
L__dinamic_adjust_value149:
;METAL_DET_LFM_ATMEGA8.c,299 :: 		cnt2=0;
	LDI        R27, 0
	STS        _cnt2+0, R27
;METAL_DET_LFM_ATMEGA8.c,300 :: 		if(old_tmr1a>old_tmr1b)old_tmr1a--;//a>b=a--
	LDS        R20, _old_tmr1a+0
	LDS        R21, _old_tmr1a+1
	LDS        R22, _old_tmr1a+2
	LDS        R23, _old_tmr1a+3
	LDS        R16, _old_tmr1b+0
	LDS        R17, _old_tmr1b+1
	LDS        R18, _old_tmr1b+2
	LDS        R19, _old_tmr1b+3
	CP         R16, R20
	CPC        R17, R21
	CPC        R18, R22
	CPC        R19, R23
	BRLT       L__dinamic_adjust_value150
	JMP        L_dinamic_adjust_value40
L__dinamic_adjust_value150:
	LDS        R16, _old_tmr1a+0
	LDS        R17, _old_tmr1a+1
	LDS        R18, _old_tmr1a+2
	LDS        R19, _old_tmr1a+3
	SUBI       R16, 1
	SBCI       R17, 0
	SBCI       R18, 0
	SBCI       R19, 0
	STS        _old_tmr1a+0, R16
	STS        _old_tmr1a+1, R17
	STS        _old_tmr1a+2, R18
	STS        _old_tmr1a+3, R19
L_dinamic_adjust_value40:
;METAL_DET_LFM_ATMEGA8.c,301 :: 		if(old_tmr1a<old_tmr1b)old_tmr1a++;//a<b=a++
	LDS        R20, _old_tmr1a+0
	LDS        R21, _old_tmr1a+1
	LDS        R22, _old_tmr1a+2
	LDS        R23, _old_tmr1a+3
	LDS        R16, _old_tmr1b+0
	LDS        R17, _old_tmr1b+1
	LDS        R18, _old_tmr1b+2
	LDS        R19, _old_tmr1b+3
	CP         R20, R16
	CPC        R21, R17
	CPC        R22, R18
	CPC        R23, R19
	BRLT       L__dinamic_adjust_value151
	JMP        L_dinamic_adjust_value41
L__dinamic_adjust_value151:
	LDS        R16, _old_tmr1a+0
	LDS        R17, _old_tmr1a+1
	LDS        R18, _old_tmr1a+2
	LDS        R19, _old_tmr1a+3
	SUBI       R16, 255
	SBCI       R17, 255
	SBCI       R18, 255
	SBCI       R19, 255
	STS        _old_tmr1a+0, R16
	STS        _old_tmr1a+1, R17
	STS        _old_tmr1a+2, R18
	STS        _old_tmr1a+3, R19
L_dinamic_adjust_value41:
;METAL_DET_LFM_ATMEGA8.c,302 :: 		}
L_dinamic_adjust_value39:
;METAL_DET_LFM_ATMEGA8.c,303 :: 		}//dinamic_adjust_value(){
L_end_dinamic_adjust_value:
	RET
; end of _dinamic_adjust_value

_efeito_sonoro_taranra:

;METAL_DET_LFM_ATMEGA8.c,311 :: 		void efeito_sonoro_taranra(){
;METAL_DET_LFM_ATMEGA8.c,314 :: 		PORTD=0; //leds apagados
	PUSH       R2
	PUSH       R3
	LDI        R27, 0
	OUT        PORTD+0, R27
;METAL_DET_LFM_ATMEGA8.c,315 :: 		lednf=0;
	IN         R27, PORTB2_bit+0
	CBR        R27, BitMask(PORTB2_bit+0)
	OUT        PORTB2_bit+0, R27
;METAL_DET_LFM_ATMEGA8.c,316 :: 		ledf=0;
	IN         R27, PORTB3_bit+0
	CBR        R27, BitMask(PORTB3_bit+0)
	OUT        PORTB3_bit+0, R27
;METAL_DET_LFM_ATMEGA8.c,317 :: 		for(a=0;a<3;a++){//gera beep 1
; a start address is: 17 (R17)
	LDI        R17, 0
; a end address is: 17 (R17)
L_efeito_sonoro_taranra42:
; a start address is: 17 (R17)
	CPI        R17, 3
	BRLO       L__efeito_sonoro_taranra153
	JMP        L_efeito_sonoro_taranra43
L__efeito_sonoro_taranra153:
;METAL_DET_LFM_ATMEGA8.c,318 :: 		gera_beep(100,240);//n. rep/periodo da nota
	PUSH       R17
	LDI        R27, 240
	MOV        R3, R27
	LDI        R27, 100
	MOV        R2, R27
	CALL       _gera_beep+0
	POP        R17
;METAL_DET_LFM_ATMEGA8.c,317 :: 		for(a=0;a<3;a++){//gera beep 1
	MOV        R16, R17
	SUBI       R16, 255
	MOV        R17, R16
;METAL_DET_LFM_ATMEGA8.c,319 :: 		}
; a end address is: 17 (R17)
	JMP        L_efeito_sonoro_taranra42
L_efeito_sonoro_taranra43:
;METAL_DET_LFM_ATMEGA8.c,320 :: 		for(a=0;a<3;a++){
; a start address is: 17 (R17)
	LDI        R17, 0
; a end address is: 17 (R17)
L_efeito_sonoro_taranra45:
; a start address is: 17 (R17)
	CPI        R17, 3
	BRLO       L__efeito_sonoro_taranra154
	JMP        L_efeito_sonoro_taranra46
L__efeito_sonoro_taranra154:
;METAL_DET_LFM_ATMEGA8.c,321 :: 		delay10ms();//delay de 30 ms
	PUSH       R17
	CALL       _delay10ms+0
	POP        R17
;METAL_DET_LFM_ATMEGA8.c,320 :: 		for(a=0;a<3;a++){
	MOV        R16, R17
	SUBI       R16, 255
	MOV        R17, R16
;METAL_DET_LFM_ATMEGA8.c,322 :: 		}
; a end address is: 17 (R17)
	JMP        L_efeito_sonoro_taranra45
L_efeito_sonoro_taranra46:
;METAL_DET_LFM_ATMEGA8.c,323 :: 		for(a=0;a<3;a++){//gera beep 2
; a start address is: 17 (R17)
	LDI        R17, 0
; a end address is: 17 (R17)
L_efeito_sonoro_taranra48:
; a start address is: 17 (R17)
	CPI        R17, 3
	BRLO       L__efeito_sonoro_taranra155
	JMP        L_efeito_sonoro_taranra49
L__efeito_sonoro_taranra155:
;METAL_DET_LFM_ATMEGA8.c,324 :: 		gera_beep(200,120);//n. rep/periodo da nota
	PUSH       R17
	LDI        R27, 120
	MOV        R3, R27
	LDI        R27, 200
	MOV        R2, R27
	CALL       _gera_beep+0
	POP        R17
;METAL_DET_LFM_ATMEGA8.c,323 :: 		for(a=0;a<3;a++){//gera beep 2
	MOV        R16, R17
	SUBI       R16, 255
	MOV        R17, R16
;METAL_DET_LFM_ATMEGA8.c,325 :: 		}
; a end address is: 17 (R17)
	JMP        L_efeito_sonoro_taranra48
L_efeito_sonoro_taranra49:
;METAL_DET_LFM_ATMEGA8.c,326 :: 		for(a=0;a<3;a++){
; a start address is: 17 (R17)
	LDI        R17, 0
; a end address is: 17 (R17)
L_efeito_sonoro_taranra51:
; a start address is: 17 (R17)
	CPI        R17, 3
	BRLO       L__efeito_sonoro_taranra156
	JMP        L_efeito_sonoro_taranra52
L__efeito_sonoro_taranra156:
;METAL_DET_LFM_ATMEGA8.c,327 :: 		delay10ms();//delay de 30 ms
	PUSH       R17
	CALL       _delay10ms+0
	POP        R17
;METAL_DET_LFM_ATMEGA8.c,326 :: 		for(a=0;a<3;a++){
	MOV        R16, R17
	SUBI       R16, 255
	MOV        R17, R16
;METAL_DET_LFM_ATMEGA8.c,328 :: 		}
; a end address is: 17 (R17)
	JMP        L_efeito_sonoro_taranra51
L_efeito_sonoro_taranra52:
;METAL_DET_LFM_ATMEGA8.c,329 :: 		for(a=0;a<3;a++){///gera beep 3
; a start address is: 17 (R17)
	LDI        R17, 0
; a end address is: 17 (R17)
L_efeito_sonoro_taranra54:
; a start address is: 17 (R17)
	CPI        R17, 3
	BRLO       L__efeito_sonoro_taranra157
	JMP        L_efeito_sonoro_taranra55
L__efeito_sonoro_taranra157:
;METAL_DET_LFM_ATMEGA8.c,330 :: 		gera_beep(120,200);//n. rep/periodo da nota
	PUSH       R17
	LDI        R27, 200
	MOV        R3, R27
	LDI        R27, 120
	MOV        R2, R27
	CALL       _gera_beep+0
	POP        R17
;METAL_DET_LFM_ATMEGA8.c,329 :: 		for(a=0;a<3;a++){///gera beep 3
	MOV        R16, R17
	SUBI       R16, 255
	MOV        R17, R16
;METAL_DET_LFM_ATMEGA8.c,331 :: 		}
; a end address is: 17 (R17)
	JMP        L_efeito_sonoro_taranra54
L_efeito_sonoro_taranra55:
;METAL_DET_LFM_ATMEGA8.c,332 :: 		}
L_end_efeito_sonoro_taranra:
	POP        R3
	POP        R2
	RET
; end of _efeito_sonoro_taranra

_detecta_metal:

;METAL_DET_LFM_ATMEGA8.c,343 :: 		void detecta_metal(){
;METAL_DET_LFM_ATMEGA8.c,350 :: 		asm WDR ;
	WDR
;METAL_DET_LFM_ATMEGA8.c,351 :: 		flag_ok=0;//reseta flag
	LDS        R27, _flag_ok+0
	CBR        R27, BitMask(_flag_ok+0)
	STS        _flag_ok+0, R27
;METAL_DET_LFM_ATMEGA8.c,352 :: 		while(!flag_ok);//aguarda ficar '1' indicando nova leitura da frequencia osc.
L_detecta_metal57:
	LDS        R27, _flag_ok+0
	SBRC       R27, BitPos(_flag_ok+0)
	JMP        L_detecta_metal58
	JMP        L_detecta_metal57
L_detecta_metal58:
;METAL_DET_LFM_ATMEGA8.c,353 :: 		new_tmr1=(long)salva_tmr1l | (long)salva_tmr1h<<8 | (long) salva_overf1<<16;
	LDS        R20, _salva_tmr1l+0
	LDI        R21, 0
	MOV        R22, R21
	MOV        R23, R21
	LDS        R16, _salva_tmr1h+0
	LDI        R17, 0
	MOV        R18, R17
	MOV        R19, R17
	MOV        R19, R18
	MOV        R18, R17
	MOV        R17, R16
	CLR        R16
	OR         R20, R16
	OR         R21, R17
	OR         R22, R18
	OR         R23, R19
	LDS        R16, _salva_overf1+0
	LDI        R17, 0
	MOV        R18, R17
	MOV        R19, R17
	MOV        R19, R17
	MOV        R18, R16
	CLR        R16
	CLR        R17
	OR         R16, R20
	OR         R17, R21
	OR         R18, R22
	OR         R19, R23
	STS        _new_tmr1+0, R16
	STS        _new_tmr1+1, R17
	STS        _new_tmr1+2, R18
	STS        _new_tmr1+3, R19
;METAL_DET_LFM_ATMEGA8.c,354 :: 		asm WDR ;
	WDR
;METAL_DET_LFM_ATMEGA8.c,355 :: 		if(new_tmr1>old_tmr1a){
	LDS        R20, _new_tmr1+0
	LDS        R21, _new_tmr1+1
	LDS        R22, _new_tmr1+2
	LDS        R23, _new_tmr1+3
	LDS        R16, _old_tmr1a+0
	LDS        R17, _old_tmr1a+1
	LDS        R18, _old_tmr1a+2
	LDS        R19, _old_tmr1a+3
	CP         R16, R20
	CPC        R17, R21
	CPC        R18, R22
	CPC        R19, R23
	BRLT       L__detecta_metal159
	JMP        L_detecta_metal59
L__detecta_metal159:
;METAL_DET_LFM_ATMEGA8.c,356 :: 		dif=new_tmr1 - old_tmr1a;//frequencia nova maior que anterior
	LDS        R0, _old_tmr1a+0
	LDS        R1, _old_tmr1a+1
	LDS        R16, _new_tmr1+0
	LDS        R17, _new_tmr1+1
	SUB        R16, R0
	SBC        R17, R1
	LDS        R0, _old_tmr1a+2
	LDS        R1, _old_tmr1a+3
	LDS        R18, _new_tmr1+2
	LDS        R19, _new_tmr1+3
	SBC        R18, R0
	SBC        R19, R1
	STS        _dif+0, R16
	STS        _dif+1, R17
	STS        _dif+2, R18
	STS        _dif+3, R19
;METAL_DET_LFM_ATMEGA8.c,357 :: 		flag_fnf=0;//indica metal no ferroso
	LDS        R27, _flag_fnf+0
	CBR        R27, BitMask(_flag_fnf+0)
	STS        _flag_fnf+0, R27
;METAL_DET_LFM_ATMEGA8.c,358 :: 		}
	JMP        L_detecta_metal60
L_detecta_metal59:
;METAL_DET_LFM_ATMEGA8.c,359 :: 		else if(new_tmr1==old_tmr1a){//sem alterao da frequncia (sem presena de metal no sensor)
	LDS        R20, _new_tmr1+0
	LDS        R21, _new_tmr1+1
	LDS        R22, _new_tmr1+2
	LDS        R23, _new_tmr1+3
	LDS        R16, _old_tmr1a+0
	LDS        R17, _old_tmr1a+1
	LDS        R18, _old_tmr1a+2
	LDS        R19, _old_tmr1a+3
	CP         R20, R16
	CPC        R21, R17
	CPC        R22, R18
	CPC        R23, R19
	BREQ       L__detecta_metal160
	JMP        L_detecta_metal61
L__detecta_metal160:
;METAL_DET_LFM_ATMEGA8.c,360 :: 		dif=0;
	LDI        R27, 0
	STS        _dif+0, R27
	STS        _dif+1, R27
	STS        _dif+2, R27
	STS        _dif+3, R27
;METAL_DET_LFM_ATMEGA8.c,361 :: 		flag_fnf=0;
	LDS        R27, _flag_fnf+0
	CBR        R27, BitMask(_flag_fnf+0)
	STS        _flag_fnf+0, R27
;METAL_DET_LFM_ATMEGA8.c,362 :: 		}
	JMP        L_detecta_metal62
L_detecta_metal61:
;METAL_DET_LFM_ATMEGA8.c,363 :: 		else if(new_tmr1<old_tmr1a){//frequencia nova menor que anterior
	LDS        R20, _new_tmr1+0
	LDS        R21, _new_tmr1+1
	LDS        R22, _new_tmr1+2
	LDS        R23, _new_tmr1+3
	LDS        R16, _old_tmr1a+0
	LDS        R17, _old_tmr1a+1
	LDS        R18, _old_tmr1a+2
	LDS        R19, _old_tmr1a+3
	CP         R20, R16
	CPC        R21, R17
	CPC        R22, R18
	CPC        R23, R19
	BRLT       L__detecta_metal161
	JMP        L_detecta_metal63
L__detecta_metal161:
;METAL_DET_LFM_ATMEGA8.c,364 :: 		dif=old_tmr1a - new_tmr1;
	LDS        R0, _new_tmr1+0
	LDS        R1, _new_tmr1+1
	LDS        R16, _old_tmr1a+0
	LDS        R17, _old_tmr1a+1
	SUB        R16, R0
	SBC        R17, R1
	LDS        R0, _new_tmr1+2
	LDS        R1, _new_tmr1+3
	LDS        R18, _old_tmr1a+2
	LDS        R19, _old_tmr1a+3
	SBC        R18, R0
	SBC        R19, R1
	STS        _dif+0, R16
	STS        _dif+1, R17
	STS        _dif+2, R18
	STS        _dif+3, R19
;METAL_DET_LFM_ATMEGA8.c,365 :: 		flag_fnf=1;//indica metal ferroso
	LDS        R27, _flag_fnf+0
	SBR        R27, BitMask(_flag_fnf+0)
	STS        _flag_fnf+0, R27
;METAL_DET_LFM_ATMEGA8.c,366 :: 		}
L_detecta_metal63:
L_detecta_metal62:
L_detecta_metal60:
;METAL_DET_LFM_ATMEGA8.c,368 :: 		if(dif<=N_MIN){    //se diferena de leituras forem menor que N_MIN
	LDS        R20, _dif+0
	LDS        R21, _dif+1
	LDS        R22, _dif+2
	LDS        R23, _dif+3
	LDI        R16, 4
	LDI        R17, 0
	LDI        R18, 0
	LDI        R19, 0
	CP         R16, R20
	CPC        R17, R21
	CPC        R18, R22
	CPC        R19, R23
	BRGE       L__detecta_metal162
	JMP        L_detecta_metal64
L__detecta_metal162:
;METAL_DET_LFM_ATMEGA8.c,369 :: 		cnt_prox=1;
	LDI        R27, 1
	STS        _cnt_prox+0, R27
;METAL_DET_LFM_ATMEGA8.c,370 :: 		cnt_it++;  //incrementa contador de iteraes
	LDS        R16, _cnt_it+0
	LDS        R17, _cnt_it+1
	MOVW       R18, R16
	SUBI       R18, 255
	SBCI       R19, 255
	STS        _cnt_it+0, R18
	STS        _cnt_it+1, R19
;METAL_DET_LFM_ATMEGA8.c,371 :: 		if(cnt_it>N_ITERACOES){  //testa se chegou a 12000 iteraes
	LDI        R16, 224
	LDI        R17, 46
	CP         R16, R18
	CPC        R17, R19
	BRLT       L__detecta_metal163
	JMP        L_detecta_metal65
L__detecta_metal163:
;METAL_DET_LFM_ATMEGA8.c,372 :: 		cnt_it=0;        //sim,zera contador de iteraes
	LDI        R27, 0
	STS        _cnt_it+0, R27
	STS        _cnt_it+1, R27
;METAL_DET_LFM_ATMEGA8.c,373 :: 		efeito_sonoro_taranra();    //chama rotina de som caracteristica
	CALL       _efeito_sonoro_taranra+0
;METAL_DET_LFM_ATMEGA8.c,374 :: 		}
L_detecta_metal65:
;METAL_DET_LFM_ATMEGA8.c,375 :: 		dinamic_adjust_value();  //rotina de autoajuste do valor de comparao da freq do osc.ext
	CALL       _dinamic_adjust_value+0
;METAL_DET_LFM_ATMEGA8.c,376 :: 		}//if(dif<N_MIN){
	JMP        L_detecta_metal66
L_detecta_metal64:
;METAL_DET_LFM_ATMEGA8.c,380 :: 		cnt_it=0;
	LDI        R27, 0
	STS        _cnt_it+0, R27
	STS        _cnt_it+1, R27
;METAL_DET_LFM_ATMEGA8.c,384 :: 		aa=dif;
; aa start address is: 18 (R18)
	LDS        R18, _dif+0
	LDS        R19, _dif+1
;METAL_DET_LFM_ATMEGA8.c,385 :: 		bb=0x2000;
; bb start address is: 21 (R21)
	LDI        R21, 0
	LDI        R22, 32
;METAL_DET_LFM_ATMEGA8.c,386 :: 		for(c=0;c<=13;c++){//14 - em 'c' se obter um valor de 0 a 13
; c start address is: 20 (R20)
	LDI        R20, 0
; bb end address is: 21 (R21)
; c end address is: 20 (R20)
L_detecta_metal67:
; c start address is: 20 (R20)
; bb start address is: 21 (R21)
; aa start address is: 18 (R18)
; aa end address is: 18 (R18)
	LDI        R16, 13
	CP         R16, R20
	BRSH       L__detecta_metal164
	JMP        L_detecta_metal68
L__detecta_metal164:
; aa end address is: 18 (R18)
;METAL_DET_LFM_ATMEGA8.c,387 :: 		asm WDR ;
; aa start address is: 18 (R18)
	WDR
;METAL_DET_LFM_ATMEGA8.c,388 :: 		if(aa & bb)break;
	MOVW       R16, R18
	AND        R16, R21
	AND        R17, R22
	MOV        R27, R16
	OR         R27, R17
	BRNE       L__detecta_metal165
	JMP        L_detecta_metal70
L__detecta_metal165:
; aa end address is: 18 (R18)
; bb end address is: 21 (R21)
	JMP        L_detecta_metal68
L_detecta_metal70:
;METAL_DET_LFM_ATMEGA8.c,389 :: 		bb=bb>>1;
; bb start address is: 21 (R21)
; aa start address is: 18 (R18)
	MOV        R16, R21
	MOV        R17, R22
	ASR        R17
	ROR        R16
	MOV        R21, R16
	MOV        R22, R17
;METAL_DET_LFM_ATMEGA8.c,386 :: 		for(c=0;c<=13;c++){//14 - em 'c' se obter um valor de 0 a 13
	MOV        R16, R20
	SUBI       R16, 255
	MOV        R20, R16
;METAL_DET_LFM_ATMEGA8.c,390 :: 		}
; aa end address is: 18 (R18)
; bb end address is: 21 (R21)
	JMP        L_detecta_metal67
L_detecta_metal68:
;METAL_DET_LFM_ATMEGA8.c,392 :: 		proximity=proximity>>2; //2  'c' ser dividido por 4 para obter apenas 3 nveis de visualizao
	MOV        R17, R20
	LSR        R17
	LSR        R17
;METAL_DET_LFM_ATMEGA8.c,394 :: 		if(proximity>=cnt_prox){//verifica se  a vez de acionar a sada conforme proximidade
	LDS        R16, _cnt_prox+0
	CP         R17, R16
	BRSH       L__detecta_metal166
	JMP        L_detecta_metal71
L__detecta_metal166:
; c end address is: 20 (R20)
;METAL_DET_LFM_ATMEGA8.c,395 :: 		cnt_prox++;
	LDS        R16, _cnt_prox+0
	SUBI       R16, 255
	STS        _cnt_prox+0, R16
;METAL_DET_LFM_ATMEGA8.c,396 :: 		}// if(proximity>cnt_prox){
	JMP        L_detecta_metal72
L_detecta_metal71:
;METAL_DET_LFM_ATMEGA8.c,398 :: 		cnt_prox=1;
; c start address is: 20 (R20)
	LDI        R27, 1
	STS        _cnt_prox+0, R27
;METAL_DET_LFM_ATMEGA8.c,399 :: 		portb=0;
	LDI        R27, 0
	OUT        PORTB+0, R27
;METAL_DET_LFM_ATMEGA8.c,400 :: 		portd=0;
	LDI        R27, 0
	OUT        PORTD+0, R27
;METAL_DET_LFM_ATMEGA8.c,401 :: 		c=c>>1;
	MOV        R17, R20
	LSR        R17
; c end address is: 20 (R20)
; c start address is: 18 (R18)
	MOV        R18, R17
;METAL_DET_LFM_ATMEGA8.c,402 :: 		if(c>5)c=5;
	LDI        R16, 5
	CP         R16, R17
	BRLO       L__detecta_metal167
	JMP        L__detecta_metal116
L__detecta_metal167:
; c end address is: 18 (R18)
; c start address is: 16 (R16)
	LDI        R16, 5
; c end address is: 16 (R16)
	JMP        L_detecta_metal73
L__detecta_metal116:
	MOV        R16, R18
L_detecta_metal73:
;METAL_DET_LFM_ATMEGA8.c,405 :: 		switch (c){
; c start address is: 16 (R16)
	JMP        L_detecta_metal74
; c end address is: 16 (R16)
;METAL_DET_LFM_ATMEGA8.c,407 :: 		case 0: led5=1;
L_detecta_metal76:
	IN         R27, PORTD6_bit+0
	SBR        R27, BitMask(PORTD6_bit+0)
	OUT        PORTD6_bit+0, R27
;METAL_DET_LFM_ATMEGA8.c,408 :: 		case 1: led4=1;
L_detecta_metal77:
	IN         R27, PORTD5_bit+0
	SBR        R27, BitMask(PORTD5_bit+0)
	OUT        PORTD5_bit+0, R27
;METAL_DET_LFM_ATMEGA8.c,409 :: 		case 2: led3=1;
L_detecta_metal78:
	IN         R27, PORTD3_bit+0
	SBR        R27, BitMask(PORTD3_bit+0)
	OUT        PORTD3_bit+0, R27
;METAL_DET_LFM_ATMEGA8.c,410 :: 		case 3: led2=1;
L_detecta_metal79:
	IN         R27, PORTD2_bit+0
	SBR        R27, BitMask(PORTD2_bit+0)
	OUT        PORTD2_bit+0, R27
;METAL_DET_LFM_ATMEGA8.c,411 :: 		case 4: led1=1;
L_detecta_metal80:
	IN         R27, PORTD1_bit+0
	SBR        R27, BitMask(PORTD1_bit+0)
	OUT        PORTD1_bit+0, R27
;METAL_DET_LFM_ATMEGA8.c,412 :: 		case 5: led0=1;
L_detecta_metal81:
	IN         R27, PORTD0_bit+0
	SBR        R27, BitMask(PORTD0_bit+0)
	OUT        PORTD0_bit+0, R27
;METAL_DET_LFM_ATMEGA8.c,413 :: 		}
	JMP        L_detecta_metal75
L_detecta_metal74:
; c start address is: 16 (R16)
	CPI        R16, 0
	BRNE       L__detecta_metal168
	JMP        L_detecta_metal76
L__detecta_metal168:
	CPI        R16, 1
	BRNE       L__detecta_metal169
	JMP        L_detecta_metal77
L__detecta_metal169:
	CPI        R16, 2
	BRNE       L__detecta_metal170
	JMP        L_detecta_metal78
L__detecta_metal170:
	CPI        R16, 3
	BRNE       L__detecta_metal171
	JMP        L_detecta_metal79
L__detecta_metal171:
	CPI        R16, 4
	BRNE       L__detecta_metal172
	JMP        L_detecta_metal80
L__detecta_metal172:
	CPI        R16, 5
	BRNE       L__detecta_metal173
	JMP        L_detecta_metal81
L__detecta_metal173:
; c end address is: 16 (R16)
L_detecta_metal75:
;METAL_DET_LFM_ATMEGA8.c,415 :: 		if(flag_fnf==1){
	LDS        R27, _flag_fnf+0
	SBRS       R27, BitPos(_flag_fnf+0)
	JMP        L_detecta_metal82
;METAL_DET_LFM_ATMEGA8.c,416 :: 		nonferrous();//apita e acende led nonferrous (led verde)
	CALL       _nonferrous+0
;METAL_DET_LFM_ATMEGA8.c,417 :: 		}
	JMP        L_detecta_metal83
L_detecta_metal82:
;METAL_DET_LFM_ATMEGA8.c,419 :: 		ferrous();//apita e acende led ferrous (led azul)
	CALL       _ferrous+0
;METAL_DET_LFM_ATMEGA8.c,420 :: 		}
L_detecta_metal83:
;METAL_DET_LFM_ATMEGA8.c,421 :: 		portb=0; //desliga leds do bargraph
	LDI        R27, 0
	OUT        PORTB+0, R27
;METAL_DET_LFM_ATMEGA8.c,422 :: 		portd=0;
	LDI        R27, 0
	OUT        PORTD+0, R27
;METAL_DET_LFM_ATMEGA8.c,423 :: 		}//else -  if(proximity>cnt_prox){
L_detecta_metal72:
;METAL_DET_LFM_ATMEGA8.c,425 :: 		}//else - if(dif<N_MIN){
L_detecta_metal66:
;METAL_DET_LFM_ATMEGA8.c,427 :: 		}//void detecta_metal(){
L_end_detecta_metal:
	RET
; end of _detecta_metal

_testa_osc_sensor:

;METAL_DET_LFM_ATMEGA8.c,436 :: 		void testa_osc_sensor(){
;METAL_DET_LFM_ATMEGA8.c,439 :: 		SREG_I_bit = 0;  // Desliga geral das interrupes
	PUSH       R2
	IN         R27, SREG_I_bit+0
	CBR        R27, BitMask(SREG_I_bit+0)
	OUT        SREG_I_bit+0, R27
;METAL_DET_LFM_ATMEGA8.c,440 :: 		nonferrous();
	CALL       _nonferrous+0
;METAL_DET_LFM_ATMEGA8.c,441 :: 		delay100ms();
	CALL       _delay100ms+0
;METAL_DET_LFM_ATMEGA8.c,442 :: 		delay100ms();
	CALL       _delay100ms+0
;METAL_DET_LFM_ATMEGA8.c,443 :: 		TCNT0=0;
	LDI        R27, 0
	OUT        TCNT0+0, R27
;METAL_DET_LFM_ATMEGA8.c,444 :: 		TOV0_bit=1;//reseta flag over flow do timer0  com '1'
	IN         R27, TOV0_bit+0
	SBR        R27, BitMask(TOV0_bit+0)
	OUT        TOV0_bit+0, R27
;METAL_DET_LFM_ATMEGA8.c,445 :: 		delay10ms();
	CALL       _delay10ms+0
;METAL_DET_LFM_ATMEGA8.c,446 :: 		new_tmr0=TCNT0;
; new_tmr0 start address is: 17 (R17)
	IN         R17, TCNT0+0
;METAL_DET_LFM_ATMEGA8.c,447 :: 		flag_ovft0=0;
	LDS        R27, _flag_ovft0+0
	CBR        R27, BitMask(_flag_ovft0+0)
	STS        _flag_ovft0+0, R27
;METAL_DET_LFM_ATMEGA8.c,448 :: 		if(TOV0_bit)flag_ovft0=1;//houve over flow do timer0
	IN         R27, TOV0_bit+0
	SBRS       R27, BitPos(TOV0_bit+0)
	JMP        L_testa_osc_sensor84
	LDS        R27, _flag_ovft0+0
	SBR        R27, BitMask(_flag_ovft0+0)
	STS        _flag_ovft0+0, R27
L_testa_osc_sensor84:
;METAL_DET_LFM_ATMEGA8.c,449 :: 		TOV0_bit=1; //apaga flag timer 0 com '1'
	IN         R27, TOV0_bit+0
	SBR        R27, BitMask(TOV0_bit+0)
	OUT        TOV0_bit+0, R27
;METAL_DET_LFM_ATMEGA8.c,450 :: 		asm WDR ;
	WDR
;METAL_DET_LFM_ATMEGA8.c,451 :: 		salva_tmr0=new_tmr0;//pega valor do timer 0 salvo
	STS        _salva_tmr0+0, R17
;METAL_DET_LFM_ATMEGA8.c,453 :: 		if(250<new_tmr0){beep_erros(2);}//freq>22khz, vai daqui para inicio do programa
	LDI        R16, 250
	CP         R16, R17
	BRLO       L__testa_osc_sensor175
	JMP        L_testa_osc_sensor85
L__testa_osc_sensor175:
	PUSH       R17
	LDI        R27, 2
	MOV        R2, R27
	CALL       _beep_erros+0
	POP        R17
	JMP        L_testa_osc_sensor86
L_testa_osc_sensor85:
;METAL_DET_LFM_ATMEGA8.c,455 :: 		if(flag_ovft0==1){beep_erros(2);}//freq>22khz, vai daqui para inicio do programa
	LDS        R27, _flag_ovft0+0
	SBRS       R27, BitPos(_flag_ovft0+0)
	JMP        L_testa_osc_sensor87
	PUSH       R17
	LDI        R27, 2
	MOV        R2, R27
	CALL       _beep_erros+0
	POP        R17
	JMP        L_testa_osc_sensor88
L_testa_osc_sensor87:
;METAL_DET_LFM_ATMEGA8.c,457 :: 		if(2<new_tmr0){
	LDI        R16, 2
	CP         R16, R17
	BRLO       L__testa_osc_sensor176
	JMP        L_testa_osc_sensor89
L__testa_osc_sensor176:
;METAL_DET_LFM_ATMEGA8.c,458 :: 		if(149>=new_tmr0){beep_erros(1);}//freq< 18khz, vai daqui para inicio do programa
	LDI        R16, 149
	CP         R16, R17
	BRSH       L__testa_osc_sensor177
	JMP        L_testa_osc_sensor90
L__testa_osc_sensor177:
	PUSH       R17
	LDI        R27, 1
	MOV        R2, R27
	CALL       _beep_erros+0
	POP        R17
L_testa_osc_sensor90:
;METAL_DET_LFM_ATMEGA8.c,459 :: 		}
L_testa_osc_sensor89:
;METAL_DET_LFM_ATMEGA8.c,460 :: 		flag_g1=1;
	LDS        R27, _flag_g1+0
	SBR        R27, BitMask(_flag_g1+0)
	STS        _flag_g1+0, R27
;METAL_DET_LFM_ATMEGA8.c,461 :: 		}//x
L_testa_osc_sensor88:
;METAL_DET_LFM_ATMEGA8.c,462 :: 		}//else{//f
L_testa_osc_sensor86:
;METAL_DET_LFM_ATMEGA8.c,464 :: 		if((new_tmr0==0)&& (flag_ovft0==0)){
	CPI        R17, 0
	BREQ       L__testa_osc_sensor178
	JMP        L__testa_osc_sensor119
L__testa_osc_sensor178:
	LDS        R27, _flag_ovft0+0
	SBRC       R27, BitPos(_flag_ovft0+0)
	JMP        L__testa_osc_sensor118
L__testa_osc_sensor117:
;METAL_DET_LFM_ATMEGA8.c,465 :: 		beep_erros(4); //sem sinal pino 5, apito longo + pausa + 4x e goto inicio
	PUSH       R17
	LDI        R27, 4
	MOV        R2, R27
	CALL       _beep_erros+0
	POP        R17
;METAL_DET_LFM_ATMEGA8.c,464 :: 		if((new_tmr0==0)&& (flag_ovft0==0)){
L__testa_osc_sensor119:
L__testa_osc_sensor118:
;METAL_DET_LFM_ATMEGA8.c,467 :: 		salva_tmr0 = 0xff - new_tmr0;
	LDI        R16, 255
	SUB        R16, R17
; new_tmr0 end address is: 17 (R17)
	STS        _salva_tmr0+0, R16
;METAL_DET_LFM_ATMEGA8.c,468 :: 		}//void testa_osc_sensor(){
L_end_testa_osc_sensor:
	POP        R2
	RET
; end of _testa_osc_sensor

_oscillator_stability:

;METAL_DET_LFM_ATMEGA8.c,476 :: 		void oscillator_stability(){
;METAL_DET_LFM_ATMEGA8.c,479 :: 		flag_g2=0;//reseta flag
	PUSH       R2
	LDS        R27, _flag_g2+0
	CBR        R27, BitMask(_flag_g2+0)
	STS        _flag_g2+0, R27
;METAL_DET_LFM_ATMEGA8.c,480 :: 		f=0;
; f start address is: 25 (R25)
	LDI        R25, 0
;METAL_DET_LFM_ATMEGA8.c,481 :: 		g=0;
; g start address is: 24 (R24)
	LDI        R24, 0
;METAL_DET_LFM_ATMEGA8.c,482 :: 		TCNT1L=0; //limpa timer1 l
	LDI        R27, 0
	OUT        TCNT1L+0, R27
;METAL_DET_LFM_ATMEGA8.c,483 :: 		TCNT1H=0; //limpa timer1 h
	LDI        R27, 0
	OUT        TCNT1H+0, R27
;METAL_DET_LFM_ATMEGA8.c,484 :: 		TCNT1L=0; //limpa timer1 l
	LDI        R27, 0
	OUT        TCNT1L+0, R27
;METAL_DET_LFM_ATMEGA8.c,485 :: 		TOV1_bit=1;//reseta flag over flow do timer1  com '1'
	IN         R27, TOV1_bit+0
	SBR        R27, BitMask(TOV1_bit+0)
	OUT        TOV1_bit+0, R27
;METAL_DET_LFM_ATMEGA8.c,486 :: 		TIMSK=0B00000101;//Liga interrupo de overflow do timer0 e timer1
	LDI        R27, 5
	OUT        TIMSK+0, R27
;METAL_DET_LFM_ATMEGA8.c,487 :: 		TOV0_bit=1;//reseta flag over flow do timer0  com '1'
	IN         R27, TOV0_bit+0
	SBR        R27, BitMask(TOV0_bit+0)
	OUT        TOV0_bit+0, R27
;METAL_DET_LFM_ATMEGA8.c,488 :: 		SREG_I_bit = 1;  // liga geral das interrupes
	IN         R27, SREG_I_bit+0
	SBR        R27, BitMask(SREG_I_bit+0)
	OUT        SREG_I_bit+0, R27
;METAL_DET_LFM_ATMEGA8.c,489 :: 		flag_ok=0;
	LDS        R27, _flag_ok+0
	CBR        R27, BitMask(_flag_ok+0)
	STS        _flag_ok+0, R27
; g end address is: 24 (R24)
; f end address is: 25 (R25)
;METAL_DET_LFM_ATMEGA8.c,490 :: 		while(!flag_ok);//aguarda ficar '1'
L_oscillator_stability94:
; g start address is: 24 (R24)
; f start address is: 25 (R25)
	LDS        R27, _flag_ok+0
	SBRC       R27, BitPos(_flag_ok+0)
	JMP        L_oscillator_stability95
	JMP        L_oscillator_stability94
L_oscillator_stability95:
;METAL_DET_LFM_ATMEGA8.c,491 :: 		old_tmr1a=(long)salva_tmr1l | (long)salva_tmr1h<<8 | (long) salva_overf1<<16;
	LDS        R20, _salva_tmr1l+0
	LDI        R21, 0
	MOV        R22, R21
	MOV        R23, R21
	LDS        R16, _salva_tmr1h+0
	LDI        R17, 0
	MOV        R18, R17
	MOV        R19, R17
	MOV        R19, R18
	MOV        R18, R17
	MOV        R17, R16
	CLR        R16
	OR         R20, R16
	OR         R21, R17
	OR         R22, R18
	OR         R23, R19
	LDS        R16, _salva_overf1+0
	LDI        R17, 0
	MOV        R18, R17
	MOV        R19, R17
	MOV        R19, R17
	MOV        R18, R16
	CLR        R16
	CLR        R17
	OR         R16, R20
	OR         R17, R21
	OR         R18, R22
	OR         R19, R23
	STS        _old_tmr1a+0, R16
	STS        _old_tmr1a+1, R17
	STS        _old_tmr1a+2, R18
	STS        _old_tmr1a+3, R19
; g end address is: 24 (R24)
; f end address is: 25 (R25)
;METAL_DET_LFM_ATMEGA8.c,493 :: 		do{
	JMP        L_oscillator_stability96
L__oscillator_stability120:
;METAL_DET_LFM_ATMEGA8.c,510 :: 		}while(flag_g2==0);  // do{
;METAL_DET_LFM_ATMEGA8.c,493 :: 		do{
L_oscillator_stability96:
;METAL_DET_LFM_ATMEGA8.c,494 :: 		asm WDR ;
; f start address is: 25 (R25)
; g start address is: 24 (R24)
	WDR
;METAL_DET_LFM_ATMEGA8.c,495 :: 		flag_ok=0;//reseta flag
	LDS        R27, _flag_ok+0
	CBR        R27, BitMask(_flag_ok+0)
	STS        _flag_ok+0, R27
; g end address is: 24 (R24)
; f end address is: 25 (R25)
;METAL_DET_LFM_ATMEGA8.c,496 :: 		while(!flag_ok);//aguarda ficar '1'
L_oscillator_stability99:
; g start address is: 24 (R24)
; f start address is: 25 (R25)
	LDS        R27, _flag_ok+0
	SBRC       R27, BitPos(_flag_ok+0)
	JMP        L_oscillator_stability100
	JMP        L_oscillator_stability99
L_oscillator_stability100:
;METAL_DET_LFM_ATMEGA8.c,497 :: 		new_tmr1=(long)salva_tmr1l | (long)salva_tmr1h<<8 | (long) salva_overf1<<16;
	LDS        R20, _salva_tmr1l+0
	LDI        R21, 0
	MOV        R22, R21
	MOV        R23, R21
	LDS        R16, _salva_tmr1h+0
	LDI        R17, 0
	MOV        R18, R17
	MOV        R19, R17
	MOV        R19, R18
	MOV        R18, R17
	MOV        R17, R16
	CLR        R16
	OR         R20, R16
	OR         R21, R17
	OR         R22, R18
	OR         R23, R19
	LDS        R16, _salva_overf1+0
	LDI        R17, 0
	MOV        R18, R17
	MOV        R19, R17
	MOV        R19, R17
	MOV        R18, R16
	CLR        R16
	CLR        R17
	OR         R20, R16
	OR         R21, R17
	OR         R22, R18
	OR         R23, R19
	STS        _new_tmr1+0, R20
	STS        _new_tmr1+1, R21
	STS        _new_tmr1+2, R22
	STS        _new_tmr1+3, R23
;METAL_DET_LFM_ATMEGA8.c,498 :: 		if(new_tmr1 > old_tmr1a) old_tmr1a++;
	LDS        R16, _old_tmr1a+0
	LDS        R17, _old_tmr1a+1
	LDS        R18, _old_tmr1a+2
	LDS        R19, _old_tmr1a+3
	CP         R16, R20
	CPC        R17, R21
	CPC        R18, R22
	CPC        R19, R23
	BRLT       L__oscillator_stability180
	JMP        L_oscillator_stability101
L__oscillator_stability180:
	LDS        R16, _old_tmr1a+0
	LDS        R17, _old_tmr1a+1
	LDS        R18, _old_tmr1a+2
	LDS        R19, _old_tmr1a+3
	SUBI       R16, 255
	SBCI       R17, 255
	SBCI       R18, 255
	SBCI       R19, 255
	STS        _old_tmr1a+0, R16
	STS        _old_tmr1a+1, R17
	STS        _old_tmr1a+2, R18
	STS        _old_tmr1a+3, R19
L_oscillator_stability101:
;METAL_DET_LFM_ATMEGA8.c,499 :: 		if(old_tmr1a > new_tmr1) old_tmr1a--;
	LDS        R20, _old_tmr1a+0
	LDS        R21, _old_tmr1a+1
	LDS        R22, _old_tmr1a+2
	LDS        R23, _old_tmr1a+3
	LDS        R16, _new_tmr1+0
	LDS        R17, _new_tmr1+1
	LDS        R18, _new_tmr1+2
	LDS        R19, _new_tmr1+3
	CP         R16, R20
	CPC        R17, R21
	CPC        R18, R22
	CPC        R19, R23
	BRLT       L__oscillator_stability181
	JMP        L_oscillator_stability102
L__oscillator_stability181:
	LDS        R16, _old_tmr1a+0
	LDS        R17, _old_tmr1a+1
	LDS        R18, _old_tmr1a+2
	LDS        R19, _old_tmr1a+3
	SUBI       R16, 1
	SBCI       R17, 0
	SBCI       R18, 0
	SBCI       R19, 0
	STS        _old_tmr1a+0, R16
	STS        _old_tmr1a+1, R17
	STS        _old_tmr1a+2, R18
	STS        _old_tmr1a+3, R19
L_oscillator_stability102:
;METAL_DET_LFM_ATMEGA8.c,500 :: 		g++;
	MOV        R16, R24
	SUBI       R16, 255
	MOV        R24, R16
;METAL_DET_LFM_ATMEGA8.c,501 :: 		if(g==0)beep_erros(3);//se houver mais de 255 iteraes acusa erro
	CPI        R16, 0
	BREQ       L__oscillator_stability182
	JMP        L_oscillator_stability103
L__oscillator_stability182:
	LDI        R27, 3
	MOV        R2, R27
	CALL       _beep_erros+0
L_oscillator_stability103:
;METAL_DET_LFM_ATMEGA8.c,502 :: 		if(old_tmr1a == new_tmr1){
	LDS        R20, _old_tmr1a+0
	LDS        R21, _old_tmr1a+1
	LDS        R22, _old_tmr1a+2
	LDS        R23, _old_tmr1a+3
	LDS        R16, _new_tmr1+0
	LDS        R17, _new_tmr1+1
	LDS        R18, _new_tmr1+2
	LDS        R19, _new_tmr1+3
	CP         R20, R16
	CPC        R21, R17
	CPC        R22, R18
	CPC        R23, R19
	BREQ       L__oscillator_stability183
	JMP        L_oscillator_stability104
L__oscillator_stability183:
;METAL_DET_LFM_ATMEGA8.c,503 :: 		f++;
	MOV        R17, R25
	SUBI       R17, 255
; f end address is: 25 (R25)
; f start address is: 18 (R18)
	MOV        R18, R17
;METAL_DET_LFM_ATMEGA8.c,504 :: 		if(f>3)flag_g2=1;
	LDI        R16, 3
	CP         R16, R17
	BRLO       L__oscillator_stability184
	JMP        L_oscillator_stability105
L__oscillator_stability184:
	LDS        R27, _flag_g2+0
	SBR        R27, BitMask(_flag_g2+0)
	STS        _flag_g2+0, R27
L_oscillator_stability105:
;METAL_DET_LFM_ATMEGA8.c,505 :: 		}
	MOV        R25, R18
; f end address is: 18 (R18)
	JMP        L_oscillator_stability106
L_oscillator_stability104:
;METAL_DET_LFM_ATMEGA8.c,507 :: 		f=0;
; f start address is: 20 (R20)
	LDI        R20, 0
;METAL_DET_LFM_ATMEGA8.c,508 :: 		old_tmr1a=new_tmr1;
	LDS        R16, _new_tmr1+0
	LDS        R17, _new_tmr1+1
	LDS        R18, _new_tmr1+2
	LDS        R19, _new_tmr1+3
	STS        _old_tmr1a+0, R16
	STS        _old_tmr1a+1, R17
	STS        _old_tmr1a+2, R18
	STS        _old_tmr1a+3, R19
; f end address is: 20 (R20)
	MOV        R25, R20
;METAL_DET_LFM_ATMEGA8.c,509 :: 		}
L_oscillator_stability106:
;METAL_DET_LFM_ATMEGA8.c,510 :: 		}while(flag_g2==0);  // do{
; f start address is: 25 (R25)
	LDS        R27, _flag_g2+0
	SBRS       R27, BitPos(_flag_g2+0)
	JMP        L__oscillator_stability120
; g end address is: 24 (R24)
; f end address is: 25 (R25)
;METAL_DET_LFM_ATMEGA8.c,513 :: 		old_tmr1b=old_tmr1a;
	LDS        R16, _old_tmr1a+0
	LDS        R17, _old_tmr1a+1
	LDS        R18, _old_tmr1a+2
	LDS        R19, _old_tmr1a+3
	STS        _old_tmr1b+0, R16
	STS        _old_tmr1b+1, R17
	STS        _old_tmr1b+2, R18
	STS        _old_tmr1b+3, R19
;METAL_DET_LFM_ATMEGA8.c,514 :: 		old_tmr1c=old_tmr1a;
	STS        _old_tmr1c+0, R16
	STS        _old_tmr1c+1, R17
	STS        _old_tmr1c+2, R18
	STS        _old_tmr1c+3, R19
;METAL_DET_LFM_ATMEGA8.c,515 :: 		PORTB=0;
	LDI        R27, 0
	OUT        PORTB+0, R27
;METAL_DET_LFM_ATMEGA8.c,516 :: 		lednf=0; //leds apagados
	IN         R27, PORTB2_bit+0
	CBR        R27, BitMask(PORTB2_bit+0)
	OUT        PORTB2_bit+0, R27
;METAL_DET_LFM_ATMEGA8.c,517 :: 		ledf=0;
	IN         R27, PORTB3_bit+0
	CBR        R27, BitMask(PORTB3_bit+0)
	OUT        PORTB3_bit+0, R27
;METAL_DET_LFM_ATMEGA8.c,518 :: 		i=255;
; i start address is: 16 (R16)
	LDI        R16, 255
; i end address is: 16 (R16)
;METAL_DET_LFM_ATMEGA8.c,519 :: 		do{  //produz breve som (apito) do grave para agudo (tuuuuiiiiii)
	JMP        L_oscillator_stability107
L__oscillator_stability121:
;METAL_DET_LFM_ATMEGA8.c,526 :: 		}while(i>100);
	MOV        R16, R18
;METAL_DET_LFM_ATMEGA8.c,519 :: 		do{  //produz breve som (apito) do grave para agudo (tuuuuiiiiii)
L_oscillator_stability107:
;METAL_DET_LFM_ATMEGA8.c,520 :: 		buzzer=1;
; i start address is: 18 (R18)
; i start address is: 16 (R16)
	IN         R27, PORTB1_bit+0
	SBR        R27, BitMask(PORTB1_bit+0)
	OUT        PORTB1_bit+0, R27
;METAL_DET_LFM_ATMEGA8.c,521 :: 		var_delay_us(i);
	PUSH       R16
	MOV        R2, R16
	CALL       _var_delay_us+0
	POP        R16
;METAL_DET_LFM_ATMEGA8.c,522 :: 		buzzer=0;
	IN         R27, PORTB1_bit+0
	CBR        R27, BitMask(PORTB1_bit+0)
	OUT        PORTB1_bit+0, R27
;METAL_DET_LFM_ATMEGA8.c,523 :: 		var_delay_us(i);
	PUSH       R16
	MOV        R2, R16
	CALL       _var_delay_us+0
	POP        R16
;METAL_DET_LFM_ATMEGA8.c,524 :: 		var_delay_us(i);
	PUSH       R16
	MOV        R2, R16
	CALL       _var_delay_us+0
	POP        R16
;METAL_DET_LFM_ATMEGA8.c,525 :: 		i--;
	MOV        R17, R16
	SUBI       R17, 1
; i end address is: 16 (R16)
; i start address is: 18 (R18)
	MOV        R18, R17
; i end address is: 18 (R18)
;METAL_DET_LFM_ATMEGA8.c,526 :: 		}while(i>100);
	LDI        R16, 100
	CP         R16, R17
	BRSH       L__oscillator_stability185
	JMP        L__oscillator_stability121
L__oscillator_stability185:
; i end address is: 18 (R18)
;METAL_DET_LFM_ATMEGA8.c,528 :: 		for(a=0;a<5;a++)delay100ms();//delay 500 ms
; a start address is: 17 (R17)
	LDI        R17, 0
; a end address is: 17 (R17)
L_oscillator_stability110:
; a start address is: 17 (R17)
	CPI        R17, 5
	BRLO       L__oscillator_stability186
	JMP        L_oscillator_stability111
L__oscillator_stability186:
	PUSH       R17
	CALL       _delay100ms+0
	POP        R17
	MOV        R16, R17
	SUBI       R16, 255
	MOV        R17, R16
; a end address is: 17 (R17)
	JMP        L_oscillator_stability110
L_oscillator_stability111:
;METAL_DET_LFM_ATMEGA8.c,529 :: 		}
L_end_oscillator_stability:
	POP        R2
	RET
; end of _oscillator_stability

_main:
	LDI        R27, 255
	OUT        SPL+0, R27
	LDI        R27, 0
	OUT        SPL+1, R27

;METAL_DET_LFM_ATMEGA8.c,535 :: 		void main() {
;METAL_DET_LFM_ATMEGA8.c,537 :: 		initial_config(); //configuraes iniciais de ports e registradores
	CALL       _initial_config+0
;METAL_DET_LFM_ATMEGA8.c,538 :: 		testa_osc_sensor();//verifica funcionamento do oscilador do sensor de metal
	CALL       _testa_osc_sensor+0
;METAL_DET_LFM_ATMEGA8.c,539 :: 		oscillator_stability(); //aguarda estabilizar o oscilador do sensor de metal
	CALL       _oscillator_stability+0
;METAL_DET_LFM_ATMEGA8.c,544 :: 		for(;;){
L_main113:
;METAL_DET_LFM_ATMEGA8.c,545 :: 		detecta_metal();//rotina de trabalho para detectar metais ferrosos e no ferrosos
	CALL       _detecta_metal+0
;METAL_DET_LFM_ATMEGA8.c,546 :: 		}//for(;;)
	JMP        L_main113
;METAL_DET_LFM_ATMEGA8.c,547 :: 		}//void main()
L_end_main:
L__main_end_loop:
	JMP        L__main_end_loop
; end of _main
